#include <iostream>

using namespace std;

int n;
int farma[2000][2000];

int provera(int x){
    int a=0;
    for (int i=0;i<n;i++){
    for (int j=0;j<n;j++){
        if (farma[i][j]==x){
        if ((a==1) && (farma[i][j-1]!=x && j!=0))
        return 0;
        if ((a==2) && (farma[i-1][j]!=x && i!=0))
            return 0;
        if (a!=2)
           a=1;
        }
    }
    if (a==1)
        a=2;
}
if (a==1 || a==2)
return 1; else
return 0;
}

int main()
{
    int k;
    cin >> n >> k;
    for (int i=0;i<n;i++)
    for (int j=0;j<n;j++){
        cin >> farma[i][j];
    }
    int pogodne=0;
    for (int i=1;i<=k;i++){
        if(provera(i))
            pogodne++;
    }
    cout << pogodne << endl;
    return 0;
}